Bug 492972 - [RHEL5.2] [IPV6] TUNNEL6: Fix incoming packet length check for inter-protocol tunnel. [NEEDINFO]
[RHEL5.2] [IPV6] TUNNEL6: Fix incoming packet length check for inter-protocol...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.2
All Linux
high Severity high
: rc
: ---
Assigned To: Jiri Pirko
Red Hat Kernel QE team
: OtherQA
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-30 19:42 EDT by Flavio Leitner
Modified: 2015-05-04 21:16 EDT (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 04:27:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
cward: needinfo? (sbeal)


Attachments (Terms of Use)
Patch from upstream with offsets fixed for RHEL-5 (1.22 KB, patch)
2009-03-30 19:44 EDT, Flavio Leitner
no flags Details | Diff

  None (edit)
Description Flavio Leitner 2009-03-30 19:42:28 EDT
Description of problem:
When IPv6 tunnel payload is less than 40(0x28), packet can be sent to 
network, received in physical interface, but not seen in IP tunnel interface. 
No counter increase in tunnel interface.

Between 2.6.18 and 2.6.25 IPv4 over IPv6 support was added in
both ip6_tunnel.c (the tunnel interface driver) and tunnel6.c
(the encapsulation demultiplexor). In 2.6.26 a trivial bug
in tunnel6.c was fixed, in

    static int tunnel46_rcv(struct sk_buff *skb)
    {
            struct xfrm6_tunnel *handler;

            if (!pskb_may_pull(skb, sizeof(struct ipv6hdr)))
                                                  ^^^^^^^
                    goto drop;

It must be iphdr of course, with the bug IPv4 packets with a size
between 20 and 40 bytes are dropped.


Version-Release number of selected component (if applicable):
2.6.18-137.el5

How reproducible:
Always

Additional info:
Patch fixing this is available in upstream:
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=82836372311a5cbf9cc5f4f47f9b56cb9edfe90d


diff --git a/net/ipv6/tunnel6.c b/net/ipv6/tunnel6.c
index 6323921..669f280 100644 (file)
--- a/net/ipv6/tunnel6.c
+++ b/net/ipv6/tunnel6.c
@@ -109,7 +109,7 @@ static int tunnel46_rcv(struct sk_buff *skb)
 {
        struct xfrm6_tunnel *handler;
 
-       if (!pskb_may_pull(skb, sizeof(struct ipv6hdr)))
+       if (!pskb_may_pull(skb, sizeof(struct iphdr)))
                goto drop;
 
        for (handler = tunnel46_handlers; handler; handler = handler->next)
Comment 1 Flavio Leitner 2009-03-30 19:44:21 EDT
Created attachment 337260 [details]
Patch from upstream with offsets fixed for RHEL-5
Comment 4 Jiri Pirko 2009-04-07 05:59:08 EDT
Test packages are here:

http://people.redhat.com/jpirko/test/bz492972/

Please provide these to customer so they can test it. If you/they need any other arch please just say so.

Thanks.
Comment 10 Don Zickus 2009-05-06 13:17:18 EDT
in kernel-2.6.18-144.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.
Comment 12 Chris Ward 2009-07-03 14:28:12 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 20 errata-xmlrpc 2009-09-02 04:27:04 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1243.html

Note You need to log in before you can comment on or make changes to this bug.